
/* this should be in a config.h */
#define YADIF_MT 1
#define YADIF_TICKS 1
#define YADIF_PREFETCH 0

#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#if YADIF_MT
#include <pthread.h>
#endif
#include <va/va_x11.h>

//#define YADIF_DEBUG 1

extern void vdr_plg_shddev_nv12ToUV_sse2(uint8_t *dstU, uint8_t *dstV, const uint8_t *src, int width);
extern void vdr_plg_shddev_nv12ToUV_ssse3(uint8_t *dstU, uint8_t *dstV, const uint8_t *src, int width);
extern void vdr_plg_shddev_UVTonv12_ssse3(uint8_t *dst, const uint8_t *srcU, const uint8_t *srcV, int width);

typedef struct {
	uint8_t* yuv[3];
#if YADIF_PREFETCH
	uint8_t* prefetch;
#endif
	int height[3];
	int width[3];
	int pitch[3]; // stored width
	int yuvsize;
} vaapi_yadif_img;

#if YADIF_MT
#define YADIF_MT_THREADS 4
typedef struct {
	pthread_mutex_t* condlock;
	pthread_cond_t* cond;
	pthread_barrier_t* barrier;
	vaapi_yadif_img **buf_imgs;
	int w[3];
	int refs[3];
	int h[3];
	int y[3];
	int y2[3];
	int tff;
	int skip_spatial;
} yadif_thread_args;

typedef struct {
	pthread_t threads[YADIF_MT_THREADS];
	pthread_mutex_t condlock;
	pthread_cond_t cond;
	pthread_barrier_t barrier;
	yadif_thread_args args[YADIF_MT_THREADS];
} yadif_threads;
#endif


#if YADIF_MT
void VaapiYadif (VADisplay *display, VAImage *src, VAImage *dst1,
	VAImage *dst2, vaapi_yadif_img *buf_imgs[], yadif_threads *threads, int tff, int skip_spatial);
void VaapiYadif_cleanup(vaapi_yadif_img *buf_imgs[], yadif_threads *threads);
#else
void VaapiYadif (VADisplay *display, VAImage *src, VAImage *dst1,
	VAImage *dst2, vaapi_yadif_img *buf_imgs[], int tff, int skip_spatial);
void VaapiYadif_cleanup(vaapi_yadif_img *buf_imgs[]);
#endif
