/*
 * A part of this file is part of Libav.
 *
 * Libav is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Libav is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with Libav; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <stdint.h>

/* this should be in a config.h */
#define PIC 1
#define ARCH_X86_64 1

#define HAVE_SSE 1
#define HAVE_SSE2 1
#define HAVE_SSSE3 1
/* MMX completly untested */
#define HAVE_MMX 0



#define FFABS(a) ((a) >= 0 ? (a) : (-(a)))
#define FFSIGN(a) ((a) > 0 ? 1 : -1)

#define FFMAX(a,b) ((a) > (b) ? (a) : (b))
#define FFMAX3(a,b,c) FFMAX(FFMAX(a,b),c)
#define FFMIN(a,b) ((a) > (b) ? (b) : (a))
#define FFMIN3(a,b,c) FFMIN(FFMIN(a,b),c)

#if HAVE_MMX
void vdr_plg_shddev_yadif_filter_line_mmx(uint8_t *dst,
	                                      uint8_t *prev, uint8_t *cur, uint8_t *next,
                                          int w, int prefs, int mrefs, int parity, int mode);
#endif
#if HAVE_SSE2
void vdr_plg_shddev_yadif_filter_line_sse2(uint8_t *dst,
                                           uint8_t *prev, uint8_t *cur, uint8_t *next,
                                           int w, int prefs, int mrefs, int parity, int mode);
#endif
#if HAVE_SSSE3
void vdr_plg_shddev_yadif_filter_line_ssse3(uint8_t *dst,
                                            uint8_t *prev, uint8_t *cur, uint8_t *next,
                                            int w, int prefs, int mrefs, int parity, int mode);
#endif
